// numărul de cifre zecimale şi primele câteva cifre exacte ale factorialului
function factorial_info(n) {
    var lgf = 0;     // suma logaritmilor zecimali ai factorilor 2, 3, ..., n
    var est = Math.pow(10, 7);  // estimează numărul de cifre iniţiale exacte (7)
    var thend = "...";          // urmează alte cifre după cele estimate exact
    for(var k=2; k<=n; k++) {
        lgf += Math.log(k) / Math.LN10;  // log în baza 10, lg(k) = LN(k) / LN(10)
    }
    var len = parseInt(lgf);    // caracteristica logaritmului în baza 10 a lui n!
    if(len < 15) { est = Math.pow(10, len); thend = ""; } // "len" cifre exacte (maxim 14)
    var mantisa = parseFloat(lgf) - len; // mantisa logaritmului lui n!
    len++;                               // numărul de cifre ale lui n!
    var cifre = parseInt(Math.pow(10,mantisa)*est);   // primele "est" cifre ale lui n!
    alert(n + "! are " + len + " cifre zecimale\n" + n + "! = " + cifre + thend);
}

function total_op_10( n ) {
    var toz = 0; 
    var ln10 = Math.LN10;
    for(var factor = 2; factor < n; factor++) { 
        var lgf = 0; 
        for(var k = 2; k <= factor; k++) {
            lgf += Math.log(k) / ln10;
        }
        toz += Math.ceil(lgf);
    }
    return toz;
}
function get_diff( nr ) {
    var toz = total_op_10( nr );
    alert("Total operaţii zecimale = "+toz+"\nîn baza 256 vor fi cam cu "+Math.floor(0.583*toz)+" mai puţine");
}

function factorial( n ) {
    var cf = new Array();
    cf[0] = 1;
    for( var f = 2; f <= n; f++) {
        var t = 0;
        for(var i = 0, s = cf.length; i < s; i++) {
            var p = t + cf[i] * f;
            cf[i] =  p % 10;
            t = Math.floor(p / 10);
        }
        while(t) {
            cf[s++] =  t % 10; 
            t = Math.floor(t / 10); 
        }
    }
    return cf.reverse().join('');
}

function factorial_hex( n ) {
    var cf = new Array();
    cf[0] = 1;
    for( var f = 2; f <= n; f++) {
        var t = 0;
        for(var i = 0, s = cf.length; i < s; i++) {
            var p = t + cf[i] * f;
            cf[i] =  p & 0xFFFF;  // = p % 65536;
            t = p >> 16;          // = Math.floor(p / 65536);
        }
        while(t) {
            cf[s++] =  t & 0xFFFF; 
            t >>= 16;  
        }
    }
    var hfac = cf[cf.length - 1].toString(16);
    for(var i = cf.length - 2; i >= 0; i--) {
        var w = cf[i].toString(16);
        while(w.length < 4) w = '0' + w;
        hfac += w;
    }
    return hfac.toUpperCase();
}

function print_fact(n, fdiv) { 
    //   $('progress').show();
    //   setTimeout(function() {
        var ta = new Date().getTime();
        var scf = factorial(n);
        var te = new Date().getTime();
        print_sir(n, fdiv, scf, (te - ta)/1000);
        //   }, 0);
}

function print_sir(n, fdiv, scf, timp) {
    var fct = $(fdiv); fct.show(); 
    var fctz = fct.firstDescendant().next();
    fctz.innerHTML = "<p><b>" + n + "!</b> are <b>" + scf.length + "</b> cifre <i>zecimale</i>. Timp: circa <b>" + timp + "</b> secunde.</p>";
    var j = 0;
    for(var i = 0, lg = scf.length; i < lg; i += 6) {
        fctz.innerHTML += scf.substring(i, i+6) + " ";
        j++;
        if(j == 8) {
            fctz.innerHTML += "<br>";
            j = 0;
        }
    }
    //   $('progress').hide();
}

var CIFRA = 6;
var BAZA = eval("1e" + CIFRA); 
var cnvHZ = {'0':0,'1':1,'2':2,'3':3,'4':4,'5':5,'6':6,'7':7,'8':8,'9':9,'A':10,'B':11,'C':12,'D':13,'E':14,'F':15};

function bignum( Z ) {
    var len_Z = Z.length; var rest = len_Z % CIFRA; var len = 0;         
    this.T = new Array(); this.T[0] = 0;       
    for( len = 0; CIFRA*(len + 1) <= len_Z; len++ ) {
        this.T[len] = parseInt( Z.substring( len_Z - CIFRA*(len + 1), len_Z - CIFRA*len ), 10 );
    }
    if( rest ) {  
        this.T[len++] = parseInt( Z.substring( 0, rest ), 10 ); 
    }
    this.len = len; 
    this.to_str = bignum_str; 
    this.mul_int = bignum_mul_int; 
}

function bignum_mul_int( n ) { 
    var i; var th = this.len;
    for( i = 0; i < th; i++ ) this.T[i] *= n;
    for( i = 0; i < th - 1; i++ ) {
        if( this.T[i] >= BAZA ) {
            n = Math.floor( this.T[i] / BAZA );
            this.T[i] = this.T[i] % BAZA;
            this.T[i+1] +=  n; 
        }    
    }
    while( this.T[ th - 1 ] >= BAZA ) { 
        this.T[ th ] = Math.floor( this.T[ th - 1 ]/BAZA );
        this.T[ th - 1 ] %= BAZA;
        this.len++;  
        th++;
    }
    return this; 
}

function bignum_str(delm) {
    var th = this.len - 1;
    var str = "" + this.T[th]; 
    while(--th >= 0) {     
        var cifre = "" + this.T[th];   
        while(cifre.length < CIFRA)  
            cifre = '0' + cifre;
        cifre = delm + cifre;
        str += cifre; 
    }
    return str;
}
function big_fact( n ) {
    var _f1 = new bignum("1");
    for(var f=2; f<=n; f++) 
        _f1.mul_int(f);
    return _f1.to_str("");
}
function print_big_fact(n, fdiv) {
    //   $('progress').show();
    //   setTimeout(function() {
        var ta = new Date().getTime();
        var scf = big_fact(n);
        var te = new Date().getTime();
        print_sir(n, fdiv, scf, (te - ta)/1000);
        //   }, 0);
}

var stop = 1;
function big_fact_rec(big, n) {
    if(n == stop) return big;
    return big_fact_rec(big.mul_int(n), n-1);
}

function print_big_fact_r(n, fdiv) {
    //   $('progress').show();
    //   setTimeout(function() {
        var ta = new Date().getTime();
        var scf = big_fact_rec(new bignum("1"), n).to_str("");
        var te = new Date().getTime();
        print_sir(n, fdiv, scf, (te - ta)/1000);
        //   }, 0);
}


function conv_dec(dh,dz) {
    var h = $(dh).innerHTML.split('');
    var nx = h.length;
    var z = new Array(); z[0] = 0; var nz = 1;
    var i = 0, j = 0, q = 0;
    for(i = 0; i < nx; i++) {
        q = 0; nz = z.length;
        for(j=0; j < nz; j++) {
            q += 16*z[j]; z[j] = q%10;
            q = Math.floor(q/10);
        }
        while(q) { 
            z[j++] = q%10;
            q = Math.floor(q/10);
        }
        q = z[0] + cnvHZ[h[i]];
        z[0] = q%10;
        q = Math.floor(q/10);
        j = 1;
        while(q) { 
            if(z[j]) q += z[j];
            z[j++] = q%10;
            q = Math.floor(q/10);
        }
    }
    format(z.reverse().join(''), dz);
    return z.length;
};

function format(scf,fhex){
    var fh=$(fhex);
    var sh="";
    var j=0;
    for(var i=0,lg=scf.length;i<lg;i+=8){
        sh+=scf.substring(i,i+8)+" ";
        j++;
        if(j==8){sh+="<br>";j=0;}
    }
    fh.innerHTML=sh;
};

function lg_factorial(n){
    var lgf=0;
    var est=Math.pow(10,7);
    var thend="...";
    for(var k=2;k<=n;k++){
        lgf+=Math.log(k)/Math.LN10;
    }
    var len=parseInt(lgf);
    if(len<15){
        est=Math.pow(10,len);
        thend="";
    }
    var mantisa=parseFloat(lgf)-len;
    len++;
    var cifre=parseInt(Math.pow(10,mantisa)*est);
    return "<b>"+n+"!</b>"+" are "+len+" cifre zecimale: <b>"+cifre+thend+"</b>";
};

